"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.updateExperiments = exports.createVariation = void 0;
Object.defineProperty(exports, "useExperiments", {
  enumerable: true,
  get: function () {
    return _hooks.useExperiments;
  }
});
var _defaults = _interopRequireDefault(require("lodash/defaults"));
var _hooks = require("./hooks");
const createVariation = number => Date.now() % number;
exports.createVariation = createVariation;
const createExperiments = (state, hash) => Object.keys(hash).reduce((acc, key) => {
  acc[key] = typeof state[key] !== 'undefined' ? state[key] : createVariation(hash[key]);
  return acc;
}, {});
const updateExperiments = (current, randomExperiments, otherExperiments, overrides) => {
  let updated = {
    ...current
  };
  if (randomExperiments) updated = createExperiments(current, randomExperiments);
  if (otherExperiments) (0, _defaults.default)(updated, otherExperiments);
  if (overrides) updated = {
    ...updated,
    ...overrides
  };
  return updated;
};
exports.updateExperiments = updateExperiments;