"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.types = exports.reducer = exports.actions = void 0;
var _updeep = _interopRequireDefault(require("updeep"));
var _store = require("./store");
const types = exports.types = {
  EXPERIMENT_SET: 'EXPERIMENT_SET',
  EXPERIMENTS_SET: 'EXPERIMENTS_SET'
};
const actions = exports.actions = {
  setExperiment(name, value) {
    return {
      type: types.EXPERIMENT_SET,
      name,
      value
    };
  },
  setExperiments(payload) {
    return {
      type: types.EXPERIMENTS_SET,
      payload
    };
  }
};
const reducer = function () {
  let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  let action = arguments.length > 1 ? arguments[1] : undefined;
  switch (action.type) {
    case types.EXPERIMENT_SET:
      {
        const {
          name,
          value
        } = action;
        const isDelete = value === null;
        const nextState = (0, _updeep.default)({
          [name]: isDelete ? undefined : value
        }, state);
        if (isDelete) delete nextState[name];
        if (typeof window !== 'undefined') (0, _store.persistExperiments)(nextState);
        return nextState;
      }
    case types.EXPERIMENTS_SET:
      {
        if (typeof window !== 'undefined') (0, _store.persistExperiments)(action.payload);
        return action.payload;
      }
    default:
      {
        return state;
      }
  }
};
exports.reducer = reducer;