"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.serializeExperiments = exports.restoreExperiments = exports.persistExperiments = exports.parseExperiments = exports.configureExperiments = void 0;
var _jsCookie = _interopRequireDefault(require("js-cookie"));
var _qs = require("qs");
let keyName;
let keyExpires;
let debugEnabled;
const configureExperiments = _ref => {
  let {
    name,
    expires,
    debug
  } = _ref;
  keyName = name;
  keyExpires = expires;
  debugEnabled = debug;
};
exports.configureExperiments = configureExperiments;
const parseExperiments = string => {
  const object = (0, _qs.parse)(string);
  Object.keys(object).forEach(key => {
    object[key] = parseInt(object[key], 10);
  });
  return object;
};
exports.parseExperiments = parseExperiments;
const serializeExperiments = object => (0, _qs.stringify)(object);
exports.serializeExperiments = serializeExperiments;
const restoreExperiments = () => parseExperiments(_jsCookie.default.get(keyName));
exports.restoreExperiments = restoreExperiments;
const persistExperiments = object => {
  const value = serializeExperiments(object);

  // Nothing to do here
  if (!value && !_jsCookie.default.get(keyName)) return;
  if (value) {
    const options = {
      expires: keyExpires,
      secure: !debugEnabled,
      SameSite: 'Lax'
    };
    _jsCookie.default.set(keyName, value, options);
  } else {
    _jsCookie.default.remove(keyName);
  }
};
exports.persistExperiments = persistExperiments;