"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getTrustedDomainRegex = exports.getResponseHook = exports.getRequestHook = exports.getLocaleHeader = exports.getErrorHandler = exports.getBaseUrl = exports.configureNetwork = void 0;
var _escapeStringRegexp = _interopRequireDefault(require("escape-string-regexp"));
let baseUrl = '';
let regex;
let requestHook;
let responseHook;
let locale;
let onError;
const configureNetwork = function () {
  let options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  baseUrl = options.baseUrl;
  regex = new RegExp(`^https:\\/\\/(?:[\\w-]+\\.)?${(0, _escapeStringRegexp.default)(options.trustedDomain)}`);
  requestHook = options.requestHook;
  responseHook = options.responseHook;
  onError = options.onError;
  locale = options.locale;
};
exports.configureNetwork = configureNetwork;
const getBaseUrl = () => baseUrl;
exports.getBaseUrl = getBaseUrl;
const getTrustedDomainRegex = () => regex;
exports.getTrustedDomainRegex = getTrustedDomainRegex;
const getLocaleHeader = () => locale;
exports.getLocaleHeader = getLocaleHeader;
const getErrorHandler = () => onError;
exports.getErrorHandler = getErrorHandler;
const getRequestHook = () => requestHook;
exports.getRequestHook = getRequestHook;
const getResponseHook = () => responseHook;
exports.getResponseHook = getResponseHook;