"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _omit = _interopRequireDefault(require("lodash/omit"));
var _request = _interopRequireDefault(require("./request"));
var _configuration = require("./configuration");
var _types = require("./types");
var _default = store => next => action => {
  if (!action.request) return next(action);
  const {
    request,
    type
  } = action;
  const state = store.getState();

  // prevent unnecessary calls
  if (request.shouldRequest && !request.shouldRequest(state)) return Promise.resolve(null);
  const options = (0, _omit.default)(request, 'shouldRequest');
  if (!options.token) options.token = state.token;
  const promise = (0, _request.default)(options).then(payload => {
    const meta = {
      isRequestActive: false,
      ...action.meta
    };
    const newAction = {
      ...(0, _omit.default)(action, 'request'),
      type: (0, _types.resolved)(type),
      meta,
      payload
    };
    next(newAction);
    return Promise.resolve(payload);
  }, payload => {
    const meta = {
      isRequestActive: false,
      ...action.meta
    };
    const newAction = {
      ...(0, _omit.default)(action, 'request'),
      type: (0, _types.rejected)(type),
      meta,
      payload
    };
    next(newAction);
    (0, _configuration.getErrorHandler)()?.(payload, options);
    if (!request.graceful) return Promise.reject(payload);
  });
  const nextAction = {
    ...(0, _omit.default)(action, 'request'),
    meta: {
      isRequestActive: true,
      ...action.meta
    }
  };
  next(nextAction);
  return promise;
};
exports.default = _default;
module.exports = exports.default;
module.exports.default = exports.default;