"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
const isServerEnv = typeof window === 'undefined';
const getDefaultState = () => ({
  activeRequestsCount: 0,
  isNetworkActive: false
});
var _default = exports.default = function _default() {
  let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : getDefaultState();
  let action = arguments.length > 1 ? arguments[1] : undefined;
  if (isServerEnv || !action.meta || typeof action.meta.isRequestActive !== 'boolean') return state;
  const diff = action.meta.isRequestActive ? 1 : -1;
  const activeRequestsCount = Math.max(state.activeRequestsCount + diff, 0);
  const isNetworkActive = Boolean(activeRequestsCount);
  return {
    activeRequestsCount,
    isNetworkActive
  };
};
module.exports = exports.default;
module.exports.default = exports.default;