"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isNetworkError = exports.isFetchable = exports.isExpired = exports.getTotalCount = exports.DEFAULT_CACHING_TIME = void 0;
const DEFAULT_CACHING_TIME = exports.DEFAULT_CACHING_TIME = 1000 * 60 * 2;
const isExpired = function (state) {
  let time = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : DEFAULT_CACHING_TIME;
  return Date.now() - state.lastFetched > time;
};
exports.isExpired = isExpired;
const isFetchable = (state, size) => {
  if (typeof state.total !== 'number') return true;
  return state.total >= size && state.collection.length < size;
};
exports.isFetchable = isFetchable;
const getTotalCount = (collection, result) => {
  if (!collection || !Array.isArray(collection)) return 0;
  const resultLength = result ? result.length : 0;
  return collection.length + resultLength * 2;
};
exports.getTotalCount = getTotalCount;
const isNetworkError = error => error?.statusCode !== undefined;
exports.isNetworkError = isNetworkError;