"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSetSession = exports.useSessionField = exports.useSession = void 0;
var _react = require("react");
var _reactRedux = require("react-redux");
var _get = _interopRequireDefault(require("lodash/get"));
var _utils = require("../utils");
var _actions = require("./actions");
const getSession = _ref => {
  let {
    session
  } = _ref;
  return session;
};
const useSession = () => (0, _utils.useShallowEqualSelector)(getSession);
exports.useSession = useSession;
const useSessionField = function (fieldPath) {
  let defaultValue = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
  const session = useSession();
  const [value, setValue] = (0, _react.useState)((0, _get.default)(session, fieldPath) ?? defaultValue);
  (0, _react.useEffect)(() => {
    setValue((0, _get.default)(session, fieldPath));
  }, [session]);
  return value;
};
exports.useSessionField = useSessionField;
const useSetSession = () => {
  const dispatch = (0, _reactRedux.useDispatch)();
  return (0, _react.useCallback)(function () {
    return dispatch((0, _actions.setSession)(...arguments));
  }, []);
};
exports.useSetSession = useSetSession;