"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.types = exports.restoreToken = exports.reducer = exports.persistToken = exports.configureToken = exports.actions = void 0;
Object.defineProperty(exports, "useToken", {
  enumerable: true,
  get: function () {
    return _hooks.useToken;
  }
});
var _jsCookie = _interopRequireDefault(require("js-cookie"));
var _hooks = require("./hooks");
let keyName;
let keyExpires;
let debugEnabled;
const configureToken = _ref => {
  let {
    name,
    expires,
    debug
  } = _ref;
  keyName = name;
  keyExpires = expires;
  debugEnabled = debug;
};
exports.configureToken = configureToken;
const types = exports.types = {
  TOKEN_SET: 'TOKEN_SET'
};
const actions = exports.actions = {
  setToken(payload) {
    return {
      type: types.TOKEN_SET,
      payload
    };
  }
};
const restoreToken = () => _jsCookie.default.get(keyName);
exports.restoreToken = restoreToken;
const persistToken = token => {
  // Nothing to do here
  if (!token && !_jsCookie.default.get(keyName)) return;
  if (token) {
    const options = {
      expires: keyExpires,
      secure: !debugEnabled,
      SameSite: 'Lax'
    };
    _jsCookie.default.set(keyName, token, options);
  } else {
    _jsCookie.default.remove(keyName);
  }
};
exports.persistToken = persistToken;
const reducer = function () {
  let state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  let action = arguments.length > 1 ? arguments[1] : undefined;
  switch (action.type) {
    case types.TOKEN_SET:
      {
        if (typeof window !== 'undefined') persistToken(action.payload);
        return action.payload;
      }
    default:
      {
        return state;
      }
  }
};
exports.reducer = reducer;